@echo off
 goto begin

.doc
    Purpose  ... Create subdirectory and unzip an archived file in it
    Author   ... Gerry J Danen
    Modified ... 04-Jan-97
    Params   ... 1 - name of .zip file without ".ZIP"
    Notes    ... A directory is created with the same name as the .zip file.
                 The .zip file is moved to this directory and unzipped.
                 Garbage files from Wildcat (zzendpad.foo) and PCBoard
                 (readme.pcb) are deleted.
                 The user can optionally be moved to the new directory, after
                 a virus scan.
                 The input .zip file is erased!
.enddoc

:begin
 bu h "Zip 2 Sub" - Create subdirectory and dump content of Zipped archive
 if [Y]==[%z2s.batch%] echo File %2 of %3

 call upcase %1
 if not exist %u%.zip goto error
 isdir %u% >nul
 if errorlevel 1 goto already_there

 md %u%
 mov %u%.zi* %u%
 cd %u%
 call unzip %u%
 erase %u%.zip
 if exist zzendpad.foo del zzendpad.foo
 if exist readme.pcb   del readme.pcb
 ds en /s
 cd ..
 d /f %u%
 goto move_there

:error
 bu s
 bu m File %u%.zip not found
 goto end

:already_there
 bu s
 bu m Directory %u% already exists

:move_there
 if [Y]==[%z2s.batch%] goto end
 bu y {y:30} Switch to sub-directory %u%
 if not errorlevel 1 goto end
 cd %u%
 call scan . /sub
 showdiz

:end
